<?php

function getUsers() {

    global $wpdb;

    $sql = " SELECT u.user_login,u.user_nicename,u.ID FROM {$wpdb->prefix}users u LEFT JOIN {$wpdb->prefix}usermeta um ON um.user_id = u.ID AND meta_key  = 'wp_user_level' ORDER BY ID DESC  ";

    return  $wpdb->get_results($sql);

}

function getPostCategory() {
    return get_categories( array('type'=>'post' ,'hide_empty' => 0 )) ;
}

function getUsersDropDown() {

    global $current_user;

    $users = getUsers();
    $html = "<select name='author_id'> ";

    foreach($users as $user) {
        $selected = $current_user->ID == $user->ID ? "selected" : NULL;
        $html .= "<option value='{$user->ID}' {$selected}>{$user->user_login}</option>";
    }

    $html .="</select>";

    return $html;

}

function getPostCategoryDropDown($category_id) {

    global $current_user;

    $categories = getPostCategory();
    $html = "<select name='category[]' multiple>";

    foreach($categories as $category) {
        $selected = $category_id == $category->term_id ? "selected" : NULL;
        $html .= "<option value='{$category->term_id}' {$selected}>{$category->name}</option>";
    }

    $html .="</select>";

    return $html;

}

function __auto_post_wiz_save() {
    if(!class_exists("PclZip")) include "libraries/pclzip.lib.php";

    $archive = new PclZip($_FILES['article_zip']['tmp_name']);
    $extracted = $archive->extract(PCLZIP_OPT_PATH, AUTO_POST_WIZ_PLUGIN_DIR.'data',PCLZIP_OPT_REMOVE_PATH, 'install/release');
    if( ! empty($extracted) ) {

        $key = $interval = $interval_inc = $post_cnt = 0;

        $schedule = '';
        $_calc_sched  = '';
        $files = $archive->listContent();
        $file_count = sizeof($files);

		$date = strtotime($_POST['date']);
		$current_time = current_time( 'timestamp' );

		foreach ( $files as $i => $file ) {

			// Set or reset the number of days to add
			if ( $key == 0 ) {
				$interval = $interval_inc * $_POST['days_ranged'];
			}

			$scheduled_date = strtotime( "+{$interval} days", $date );
			$scheduled_time = mktime(
				rand( 0, 23 ),
				rand( 1, 59 ),
				0,
				date( "m", $scheduled_date ),
				date( "d", $scheduled_date ),
				date( "Y", $scheduled_date )
			);

			// For the first schedule, ensure that we generate a correct future scheduled_time.
			if ( $interval_inc == 0 && $scheduled_time <= $current_time ) {
				$scheduled_time = strtotime( "+1 minute", $current_time );
			}

            $path =  'data/'.$file['filename'];

            $title =  ucfirst( preg_replace('/\s{2,}/', ' ', basename( AUTO_POST_WIZ_PLUGIN_DIR.$path, '.txt' ) ) );

            $content = file_get_contents( AUTO_POST_WIZ_PLUGIN_DIR.$path );
            $content = preg_replace( '((https?://)?(http?://))', '', $content );
            $regex = '@((https?://)?([-\w]+\.[-\w\.]+)+\w(:\d+)?(/([-\w/_\.\,]*(\?\S+)?)?)*)@';
            $link_newtab = ($_POST['link_newtab'] == 1 ) ? "target='_blank'" : NULL;
            $content = preg_replace( $regex, '<a href="http://$1" '.$link_newtab.'>$1</a>', $content );

            $array = array(
                'post_author'   => $_POST['author_id'] ,
                'post_category' => $_POST['category'],
                'post_status'   => 'future',
                'post_title'    => $title,
                'post_content'  => $content,
                'post_date'     => date( "Y-m-d H:i:s", $scheduled_time )
            );

            // echo '<pre>'; print_r($array); echo '</pre>';
            $post_id = wp_insert_post( $array );
			if( is_int( $post_id ) ) $post_cnt++;

			// Increment the days multiplier only when key equals zero
			if ( $key == 0 ) {
				$interval_inc++;
			}

			$key++;
			// Reset the key to zero when the max number of posts is met.
			if ( $key >= $_POST['frequency'] ) {
				$key = 0;
			}
		}

        $remove_path = AUTO_POST_WIZ_PLUGIN_DIR.'data/';
        rmdirRecursive($remove_path);

        return "Success! {$post_cnt} article(s) has been added. You can check the queue list <a href='edit.php?post_status=future&post_type=post'>here</a>";

    }
    else {
        return 'Processes Failed! : '.$archive->errorInfo(true);
    }

}

function getEntriesAutoB() {

    global $wpdb;

    return $wpdb->get_results("SELECT *,(SELECT COUNT(*)  FROM ".$wpdb->prefix."auto_post_wiz_textfiles WHERE entry_id =entries.id  ) as content_count FROM ".$wpdb->prefix."auto_post_wiz_entries"." entries ORDER BY id DESC ");

}

function generateFileName() {

    $chars = "abcdefghijkmnopqrstuvwxyz0123456789";
    srand((double)microtime()*1000000);
    $i = 0;
    $string = '' ;

    while ($i <= 7) {

        $num = rand() % 33;
        $tmp = substr($chars, $num, 1);
        $string = $string . $tmp;
        $i++;

    }

    return $string;

}





function rmdirRecursive($dir) {

    foreach(scandir($dir) as $file) {
        if ('.' === $file || '..' === $file) continue;
        if (is_dir("$dir/$file")) rmdirRecursive("$dir/$file");
        else unlink("$dir/$file");
    }

    rmdir($dir);

}
function calculateSchedule($date_start,$interval) {

    $unix =  strtotime("+{$interval}days",$date_start);
    #echo " --{$date_start} this part should be incremented by {$interval}";
    return  array('unix' => $unix , 'string' => date('m/d/Y',$unix));

}

function createSchedule($date,$frequency,$interval,$i) {

    if($i < $frequency   && $i > 0 ) return $date;

    $return = calculateSchedule($date,$interval);
    return  $return['unix'];

}

?>
